'' **************************************************************************************
'' **************************************************************************************
'' * editor-tabs: 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60              *
'' **************************************************************************************

CON
    _clkmode            = xtal1 + pll16x
    _xinfreq            = 5_000_000
    _stack              = 500
     
     ' ADC MCP3208 pins
    mcp3208clk          = 15
    mcp3208di           = 14
    mcp3208do           = 13
    mcp3208cs           = 12    

    ' debug - USE onboard pins
    pcDebugRX           = 31
    pcDebugTX           = 30
     
    ' serial baud rates  
    pcDebugBaud         = 115200  ' 57600, 115200 or 256000 only
     
  
OBJ
    debug             :     "Debug_PC" 
  
VAR
    long    channel, adcMUX, data1
 
  
PUB Start
    ' start the PC debug object
    debug.startx(pcDebugRX,pcDebugTX,pcDebugBaud)

    dira[mcp3208clk]~~
    dira[mcp3208cs]~~
    dira[mcp3208do]~~
    dira[mcp3208di]~

    outa[mcp3208cs]~
    waitcnt(clkfreq/5+cnt)
    outa[mcp3208cs]~~

    repeat

        repeat channel from 0 to 7

            debug.str(string("is -> ch"))
            debug.dec(channel)
            debug.str(string(", "))
                    
            adcMUX := %0001_1000 + channel

            debug.bin(adcMUX,8)            

            outa[mcp3208clk]~
            outa[mcp3208cs]~
            outa[mcp3208do]~

            shiftout(adcMUX,8)

            debug.str(string(", "))            

            outa[mcp3208clk]~
            outa[mcp3208clk]~~

            outa[mcp3208clk]~
            outa[mcp3208clk]~~

            outa[mcp3208clk]~

            data1 := shiftin(12)
            
            outa[mcp3208cs]~~

            debug.str(string(", "))
            debug.dec(data1)
            debug.putc(13)
        debug.putc(13)                                  
                                                            



PRI ShiftIn(spiBitCnt) : result | i3, spidata1
    spidata1 := 0
    
    repeat i3 from 0 to spiBitCnt-1
        ' clock
        outa[mcp3208clk]~
        outa[mcp3208clk]~~

        ' data
        spidata1 <<= 1        
        spidata1 |= ina[mcp3208di]
        
    return spiData1
            
        

PRI ShiftOut(spiData,spiBitCnt) | i2, data, mask

    mask := %1 << spiBitCnt
    
    repeat i2 from 0 to spiBitCnt-1
        ' data
        mask >>= 1        
        if spiData & mask
            debug.putc("x")
            outa[mcp3208do]~~
        else
            debug.putc("o")        
            outa[mcp3208do]~                             

        ' clock
        outa[mcp3208clk]~~
        outa[mcp3208clk]~            
            
    